% Random number generators
% Uniform Distribution
x = rand(5)
x = rand(5, 1)

x = rand(1000, 1);
histogram(x);

a = -2;
b =  2;
x = rand(1000, 1) * (b - a) + a;
histogram(x);

% Normal Distribution
y = randn(5, 1)

y = randn(1000, 1);
histogram(y);

mu = 5;
sigma = 5;
y = (randn(1000, 1) + mu) * sigma;
histogram(y);

% Random Number Generator
s = rng;
rand(5, 1)
rand(5, 1)

% Restore rng
rng(s);
rand(5, 1)
rand(5, 1)

% Integrate f(x, y) = x^2 over the disk centered at the origin with radius 1
f = @(x, y) x.^2;
xmin =-1;
xmax = 1;
ymin1 = -1;
ymax1 =  1;
I_wrong = integral2(f, xmin, xmax, ymin1, ymax1)  % WRONG!
ymin2 = @(x) -sqrt(1 - x.^2);
ymax2 = @(x)  sqrt(1 - x.^2);
I_exact = integral2(f, xmin, xmax, ymin2, ymax2)

% Monte Carlo Integration for f(x, y) = x^2 over the disk centered at the origin with radius 1
ymin =-1;
ymax = 1;
N = 100000;
x = rand(N, 1) * (xmax - xmin) + xmin;
y = rand(N, 1) * (ymax - ymin) + ymin;
V = (ymax - ymin) * (xmax - xmin);
% S1 and S2 is checking whether points are in the region being integrated
S1 = @(x, y) y >= -sqrt(1 - x.^2) & y <= sqrt(1 - x.^2);   % More general
S2 = @(x, y) (x.^2 + y.^2) <= 1;                   % Equivalent to S1
I_monte_carlo_1 = V / N * sum(f(x, y) .* S1(x, y))
I_monte_carlo_2 = V / N * sum(f(x, y) .* S2(x, y))

